'use strict';

// This module handles the Locations

/* global appCore */
function MapLocations() {
    var self = this;

    var locations = [];

    self.open = function()
    {
        appCore.setActiveOverlay('locations');

        $.get('locations/locations-tpl.html', function(data) {

            // Add template to DOM
            $('#app-container').append(data);

            var lc = $('#locations');

            // Retrieve the locations from the database and append them
            IMWS.get('v1/geolocation').then(function(response) {
                locations = response.locations;

                var row = '<div class="row">';

                locations.forEach(function(l) {
                    var col = '<div class="col-xs-4 col-sm-3" style=""><a id="' + l.guid + '" class="loc-a"><h4>' + l.name +  '</h4>' + '</a></div>';
                    row = row.concat(col);
                });

                row += '</div>';
                lc.append(row);

                $('#locations-container .loc-a').click(function(e) {
                    appCore.gotoLocation(this.id);
                    self.close();
                });
            });

            // Translate the modal and all children
            IMatchTranslate.translateElement('#locations-container');

            $('#locations-container-close').click(self.close);

            $('#locations-container').css('width','100%');
            $('#locations-container').css('height','100%');
        });

        $(document).keydown(function(event) {
            if (event.which === 27) { // ESC
                self.close();
            }
        });        
    }

    self.close = function()
    {
        $('#locations-container').css('width','0%');
        $('#locations-container').css('height','0%');
        $('#locations-container').remove();
        
        appCore.setActiveOverlay('');
    }
}
